package com.ejie.ab79.dao.inspecciones;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.inspecciones.CampainasInspeccion;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.model.procedimientos.Procedimientos;
import com.ejie.ab79.model.protocolos.Protocolos;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * CampainasInspeccionDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class CampainasInspeccionDaoImpl implements CampainasInspeccionDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDCAMPAINA", "IDDIRECCION",
			"DESCRIPCIONCASTELLANO", "DESCRIPCIONEUSKERA", "FECHAINICIO", "FECHAFIN", "FECHAREGISTRO",
			"USUARIOREGISTRO", "DIRECCIONDESCES", "DIRECCIONDESCEU", "PROCEDIMIENTODESCES", "PROCEDIMIENTODESCEU",
			"COUNT_DOCUMENTOS" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<CampainasInspeccion> rwMap = new RowMapper<CampainasInspeccion>() {
		public CampainasInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			CampainasInspeccion campaina = new CampainasInspeccion();

			campaina.setIdCampaina(resultSet.getInt("IDCAMPAINA"));
			campaina.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			campaina.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));
			campaina.setFechaInicio(resultSet.getDate("FECHAINICIO"));
			campaina.setFechaFin(resultSet.getDate("FECHAFIN"));
			campaina.setIdentificadorCampaina(resultSet.getString("IDENTIFICADORCAMPAINA"));
			campaina.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			campaina.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			campaina.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			campaina.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));
			campaina.setCountDocumentos(resultSet.getInt("COUNT_DOCUMENTOS"));

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DIRECCIONDESCES"));
			direccion.setDescripcionEuskera(resultSet.getString("DIRECCIONDESCEU"));

			Procedimientos procedimiento = new Procedimientos();
			procedimiento.setIdProcedimiento(resultSet.getInt("IDPROCEDIMIENTO"));
			procedimiento.setDescripcionEs(resultSet.getString("PROCEDIMIENTODESCES"));
			procedimiento.setDescripcionEu(resultSet.getString("PROCEDIMIENTODESCEU"));
			procedimiento.setCodProcedureId(resultSet.getString("CODPROCEDUREID"));

			Protocolos protocoloAux = new Protocolos();
			protocoloAux.setIdProtocolo(resultSet.getInt("IDPROTOCOLO"));
			protocoloAux.setDescripcionCastellano(resultSet.getString("PROTOCOLODESCES"));
			protocoloAux.setDescripcionEuskera(resultSet.getString("PROTOCOLODESCEU"));

			campaina.setDireccion(direccion);
			campaina.setProcedimiento(procedimiento);
			campaina.setProtocolo(protocoloAux);

			return campaina;

		}
	};

	private RowMapper<CampainasInspeccion> rwMapREST = new RowMapper<CampainasInspeccion>() {
		public CampainasInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			CampainasInspeccion campaina = new CampainasInspeccion();
			campaina.setIdCampaina(resultSet.getInt("IDCAMPAINA"));
			campaina.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			campaina.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));
			campaina.setIdentificadorCampaina(resultSet.getString("IDENTIFICADORCAMPAINA"));

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));

			Procedimientos procedimiento = new Procedimientos();
			procedimiento.setIdProcedimiento(resultSet.getInt("IDPROCEDIMIENTO"));

			Protocolos protocoloAux = new Protocolos();
			protocoloAux.setIdProtocolo(resultSet.getInt("IDPROTOCOLO"));

			campaina.setDireccion(direccion);
			campaina.setProcedimiento(procedimiento);
			campaina.setProtocolo(protocoloAux);

			return campaina;

		}
	};

	private RowMapper<CampainasInspeccion> rwMapPK = new RowMapper<CampainasInspeccion>() {
		public CampainasInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new CampainasInspeccion(resultSet.getInt("IDCAMPAINA"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<CampainasInspeccion>> rwMapJerarquia = new RowMapper<JerarquiaDto<CampainasInspeccion>>() {
		public JerarquiaDto<CampainasInspeccion> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			CampainasInspeccion campaina = new CampainasInspeccion();

			campaina.setIdCampaina(resultSet.getInt("IDCAMPAINA"));
			campaina.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			campaina.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));
			campaina.setFechaInicio(resultSet.getDate("FECHAINICIO"));
			campaina.setFechaFin(resultSet.getDate("FECHAFIN"));
			campaina.setIdentificadorCampaina(resultSet.getString("IDENTIFICADORCAMPAINA"));
			campaina.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			campaina.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			campaina.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			campaina.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DIRECCIONDESCES"));
			direccion.setDescripcionEuskera(resultSet.getString("DIRECCIONDESCEU"));

			Procedimientos procedimiento = new Procedimientos();
			procedimiento.setIdProcedimiento(resultSet.getInt("IDPROCEDIMIENTO"));
			procedimiento.setDescripcionEs(resultSet.getString("PROCEDIMIENTODESCES"));
			procedimiento.setDescripcionEu(resultSet.getString("PROCEDIMIENTODESCEU"));
			procedimiento.setCodProcedureId(resultSet.getString("CODPROCEDUREID"));

			campaina.setDireccion(direccion);
			campaina.setProcedimiento(procedimiento);

			JerarquiaDto<CampainasInspeccion> jerarquia = new JerarquiaDto<CampainasInspeccion>();
			jerarquia.setModel(campaina);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	@Override
	public Integer getNextIdCampainaTurismo() {
		return this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7902T00T.NEXTVAL FROM DUAL", Integer.class);
	}

	@Override
	public Integer getNextIdCampainaComercio() {
		return this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7902T00C.NEXTVAL FROM DUAL", Integer.class);
	}

	/**
	 * Inserts a single row in the CampainasInspeccion table.
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion
	 * @return CampainasInspeccion
	 */
	public CampainasInspeccion add(CampainasInspeccion campainasinspeccion) {

		int idCampaina = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7902T00.NEXTVAL FROM DUAL", Integer.class);
		campainasinspeccion.setIdCampaina(idCampaina);

		String query = "INSERT INTO CAMPAINAS_INSPECCION (ID_CAMPAINA, ID_DIRECCION, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA, FECHA_INICIO, FECHA_FIN, IDENTIFICADOR_CAMPAINA, ID_PROCEDIMIENTO, ID_PROTOCOLO, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,?,?,?,?,?,?)";
		this.jdbcTemplate.update(query, campainasinspeccion.getIdCampaina(),
				campainasinspeccion.getDireccion().getIdDireccion(), campainasinspeccion.getDescripcionCastellano(),
				campainasinspeccion.getDescripcionEuskera(), campainasinspeccion.getFechaInicio(),
				campainasinspeccion.getFechaFin(), campainasinspeccion.getIdentificadorCampaina(),
				campainasinspeccion.getProcedimiento().getIdProcedimiento(),
				campainasinspeccion.getProtocolo().getIdProtocolo(), campainasinspeccion.getFechaRegistro(),
				campainasinspeccion.getUsuarioRegistro());
		return campainasinspeccion;
	}

	/**
	 * Updates a single row in the CampainasInspeccion table.
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion
	 * @return CampainasInspeccion
	 */
	public CampainasInspeccion update(CampainasInspeccion campainasinspeccion) {
		String query = "UPDATE CAMPAINAS_INSPECCION SET ID_DIRECCION=?, ID_PROCEDIMIENTO=?, DESCRIPCION_CASTELLANO=?, DESCRIPCION_EUSKERA=?, FECHA_INICIO=?, FECHA_FIN=?, IDENTIFICADOR_CAMPAINA=?, ID_PROTOCOLO = ?, FECHA_ULTMODIFICACION=?, USUARIO_ULTMODIFICACION=? WHERE ID_CAMPAINA=?";
		this.jdbcTemplate.update(query, campainasinspeccion.getDireccion().getIdDireccion(),
				campainasinspeccion.getProcedimiento().getIdProcedimiento(),
				campainasinspeccion.getDescripcionCastellano(), campainasinspeccion.getDescripcionEuskera(),
				campainasinspeccion.getFechaInicio(), campainasinspeccion.getFechaFin(),
				campainasinspeccion.getIdentificadorCampaina(), campainasinspeccion.getProtocolo().getIdProtocolo(),
				campainasinspeccion.getFechaUltmodificacion(), campainasinspeccion.getUsuarioUltmodificacion(),
				campainasinspeccion.getIdCampaina());
		return campainasinspeccion;
	}

	/**
	 * Finds a single row in the CampainasInspeccion table.
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion
	 * @return CampainasInspeccion
	 */
	@Transactional(readOnly = true)
	public CampainasInspeccion find(CampainasInspeccion campainasinspeccion) {
		StringBuilder query = new StringBuilder();
		query.append(
				"SELECT t1.ID_CAMPAINA IDCAMPAINA, t1.ID_DIRECCION IDDIRECCION, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA");
		query.append(
				", t1.FECHA_INICIO FECHAINICIO, t1.FECHA_FIN FECHAFIN, t1.IDENTIFICADOR_CAMPAINA IDENTIFICADORCAMPAINA, t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.ID_PROTOCOLO IDPROTOCOLO");
		query.append(
				", t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION");
		query.append(", t2.DESCRIPCION_CASTELLANO DIRECCIONDESCES, t2.DESCRIPCION_EUSKERA DIRECCIONDESCEU");
		query.append(
				", t3.DESCRIPCION_CASTELLANO PROCEDIMIENTODESCES, t3.DESCRIPCION_EUSKERA PROCEDIMIENTODESCEU, t3.COD_PROCEDURE_ID CODPROCEDUREID");
		query.append(", t4.DESCRIPCION_CASTELLANO PROTOCOLODESCES, t4.DESCRIPCION_EUSKERA PROTOCOLODESCEU");

		// Para saber cuantos documentos asociados tiene la campaina
		query.append(
				",(SELECT COUNT(1) FROM REL_CAM_DOC WHERE REL_CAM_DOC.ID_CAMPAINA = t1.ID_CAMPAINA) COUNT_DOCUMENTOS ");

		query.append(" FROM CAMPAINAS_INSPECCION t1, DIRECCIONES t2, PROCEDIMIENTOS t3, PROTOCOLOS t4");
		query.append(
				" WHERE t1.ID_CAMPAINA = ? AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_PROCEDIMIENTO = t3.ID_PROCEDIMIENTO(+)");
		query.append(" AND t1.ID_PROTOCOLO = t4.ID_PROTOCOLO(+)");

		List<CampainasInspeccion> campainasinspeccionList = this.jdbcTemplate.query(query.toString(), this.rwMap,
				campainasinspeccion.getIdCampaina());
		return (CampainasInspeccion) DataAccessUtils.uniqueResult(campainasinspeccionList);
	}

	/**
	 * Removes a single row in the CampainasInspeccion table.
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion
	 * @return
	 */
	public void remove(CampainasInspeccion campainasinspeccion) {
		String query = "DELETE FROM CAMPAINAS_INSPECCION WHERE ID_CAMPAINA=?";
		this.jdbcTemplate.update(query, campainasinspeccion.getIdCampaina());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<CampainasInspeccion> getMultiple(CampainasInspeccion filterCampainasInspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterCampainasInspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, CampainasInspeccion.class,
				params, "ID_CAMPAINA");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the CampainasInspeccion table.
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<CampainasInspeccion>
	 */
	@Transactional(readOnly = true)
	public List<CampainasInspeccion> findAll(CampainasInspeccion campainasinspeccion, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder();
		query.append(
				"SELECT  t1.ID_CAMPAINA IDCAMPAINA,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA");
		query.append(
				",t1.FECHA_INICIO FECHAINICIO,t1.FECHA_FIN FECHAFIN,t1.IDENTIFICADOR_CAMPAINA IDENTIFICADORCAMPAINA,t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.ID_PROTOCOLO IDPROTOCOLO");
		query.append(
				",t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION");
		query.append(",t2.DESCRIPCION_CASTELLANO DIRECCIONDESCES,t2.DESCRIPCION_EUSKERA DIRECCIONDESCEU");
		query.append(
				",t3.DESCRIPCION_CASTELLANO PROCEDIMIENTODESCES,t3.DESCRIPCION_EUSKERA PROCEDIMIENTODESCEU,t3.COD_PROCEDURE_ID CODPROCEDUREID");
		query.append(", t4.DESCRIPCION_CASTELLANO PROTOCOLODESCES, t4.DESCRIPCION_EUSKERA PROTOCOLODESCEU");

		// Para saber cuantos documentos asociados tiene la campaina
		query.append(
				",(SELECT COUNT(1) FROM REL_CAM_DOC WHERE REL_CAM_DOC.ID_CAMPAINA = t1.ID_CAMPAINA) COUNT_DOCUMENTOS ");

		query.append(" FROM CAMPAINAS_INSPECCION t1, DIRECCIONES t2, PROCEDIMIENTOS t3, PROTOCOLOS t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(campainasinspeccion);
		StringBuilder where = new StringBuilder();
		query.append(
				" WHERE 1=1 AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_PROCEDIMIENTO = t3.ID_PROCEDIMIENTO(+) ");
		query.append(" AND t1.ID_PROTOCOLO = t4.ID_PROTOCOLO(+)");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					CampainasInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<CampainasInspeccion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<CampainasInspeccion> findAllREST(CampainasInspeccion filterCampainas) {
		StringBuilder query = new StringBuilder();
		query.append(
				"SELECT t1.ID_CAMPAINA IDCAMPAINA, t1.ID_DIRECCION IDDIRECCION, t1.IDENTIFICADOR_CAMPAINA IDENTIFICADORCAMPAINA, t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.ID_PROTOCOLO IDPROTOCOLO, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA");

		query.append(" FROM CAMPAINAS_INSPECCION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(filterCampainas);
		StringBuilder where = new StringBuilder();
		query.append(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return (List<CampainasInspeccion>) this.jdbcTemplate.query(query.toString(), this.rwMapREST, params.toArray());
	}

	/**
	 * Finds rows in the CampainasInspeccion table using like.
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<CampainasInspeccion>
	 */
	@Transactional(readOnly = true)
	public List<CampainasInspeccion> findAllLike(CampainasInspeccion campainasinspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder();
		query.append(
				"SELECT  t1.ID_CAMPAINA IDCAMPAINA,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA");
		query.append(
				",t1.FECHA_INICIO FECHAINICIO,t1.FECHA_FIN FECHAFIN,t1.IDENTIFICADOR_CAMPAINA IDENTIFICADORCAMPAINA,t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.ID_PROTOCOLO IDPROTOCOLO");
		query.append(
				",t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION");
		query.append(",t2.DESCRIPCION_CASTELLANO DIRECCIONDESCES,t2.DESCRIPCION_EUSKERA DIRECCIONDESCEU");
		query.append(
				",t3.DESCRIPCION_CASTELLANO PROCEDIMIENTODESCES,t3.DESCRIPCION_EUSKERA PROCEDIMIENTODESCEU,t3.COD_PROCEDURE_ID CODPROCEDUREID ");
		query.append(", t4.DESCRIPCION_CASTELLANO PROTOCOLODESCES, t4.DESCRIPCION_EUSKERA PROTOCOLODESCEU ");

		// Para saber cuantos documentos asociados tiene la campaina
		query.append(
				",(SELECT COUNT(1) FROM REL_CAM_DOC WHERE REL_CAM_DOC.ID_CAMPAINA = t1.ID_CAMPAINA) COUNT_DOCUMENTOS ");

		query.append(" FROM CAMPAINAS_INSPECCION t1, DIRECCIONES t2, PROCEDIMIENTOS t3, PROTOCOLOS t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(campainasinspeccion, startsWith);
		StringBuilder where = new StringBuilder();
		query.append(
				" WHERE 1=1 AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_PROCEDIMIENTO = t3.ID_PROCEDIMIENTO(+) ");
		query.append(" AND t1.ID_PROTOCOLO = t4.ID_PROTOCOLO(+)");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query);
		}

		return (List<CampainasInspeccion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public Integer calcularNumeroInspeccionados(CampainasInspeccion campainasInspeccion) {
		String query = "SELECT COUNT(1) NUMINSPECCIONADOS FROM INSPECCIONES t1 WHERE t1.ID_CAMPAINA = ?";
		List<Object> params = new ArrayList<Object>();
		params.add(campainasInspeccion.getIdCampaina()); 
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the CampainasInspeccion table.
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(CampainasInspeccion campainasinspeccion) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM CAMPAINAS_INSPECCION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(campainasinspeccion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the CampainasInspeccion table using like.
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(CampainasInspeccion campainasinspeccion, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM CAMPAINAS_INSPECCION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(campainasinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of CampainasInspeccion selected for rup_table
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<CampainasInspeccion>>
	 */
	@Override
	public List<TableRowDto<CampainasInspeccion>> reorderSelection(CampainasInspeccion campainasinspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_CAMPAINA IDCAMPAINA,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_INICIO FECHAINICIO,t1.FECHA_FIN FECHAFIN,t1.IDENTIFICADOR_CAMPAINA IDENTIFICADORCAMPAINA,t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.DESCRIPCION_CASTELLANO DIRECCIONDESCES,t2.DESCRIPCION_EUSKERA DIRECCIONDESCEU,t3.DESCRIPCION_CASTELLANO PROCEDIMIENTOdESCES,t3.DESCRIPCION_EUSKERA PROCEDIMIENTODESCEU,t3.COD_PROCEDURE_ID CODPROCEDUREID ");
		// FROM
		query.append("FROM CAMPAINAS_INSPECCION t1, DIRECCIONES t2, PROCEDIMIENTOS t3 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(campainasinspeccion, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_PROCEDIMIENTO = t3.ID_PROCEDIMIENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				CampainasInspeccion.class, filterParamList, "ID_CAMPAINA");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<CampainasInspeccion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            CampainasInspeccion
	 * @param searchParams
	 *            CampainasInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<CampainasInspeccion>>
	 */
	@Override
	public List<TableRowDto<CampainasInspeccion>> search(CampainasInspeccion filterParams,
			CampainasInspeccion searchParams, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_CAMPAINA IDCAMPAINA,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_INICIO FECHAINICIO,t1.FECHA_FIN FECHAFIN,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM CAMPAINAS_INSPECCION t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				CampainasInspeccion.class, filterParamList, searchSQL, searchParamList, from_alias, "ID_CAMPAINA");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<CampainasInspeccion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filtercampainasinspeccion
	 *            CampainasInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(CampainasInspeccion filtercampainasinspeccion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_CAMPAINA IDCAMPAINA,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_INICIO FECHAINICIO,t1.FECHA_FIN FECHAFIN,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM CAMPAINAS_INSPECCION t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filtercampainasinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				CampainasInspeccion.class, query, params, "ID_CAMPAINA");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical CampainasInspeccion table.
	 *
	 * @param filterCampainasInspeccion
	 *            CampainasInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<CampainasInspeccion>>
	 */
	@Override
	public List<JerarquiaDto<CampainasInspeccion>> findAllLikeJerarquia(CampainasInspeccion filterCampainasInspeccion,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_CAMPAINA IDCAMPAINA,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_INICIO FECHAINICIO,t1.FECHA_FIN FECHAFIN,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM CAMPAINAS_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("CAMPAINAS_INSPECCION");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterCampainasInspeccion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_CAMPAINA", "ID_PADRE", "NOMBRE",
				from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					CampainasInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterCampainasInspeccion
	 *            CampainasInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(CampainasInspeccion filterCampainasInspeccion,
			TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM CAMPAINAS_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("CAMPAINAS_INSPECCION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterCampainasInspeccion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_CAMPAINA", "ID_PADRE",
				from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterCampainasInspeccion
	 *            CampainasInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<CampainasInspeccion>>
	 */
	@Override
	public List<TableRowDto<CampainasInspeccion>> findAllChild(CampainasInspeccion filterCampainasInspeccion,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM CAMPAINAS_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("CAMPAINAS_INSPECCION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterCampainasInspeccion, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_CAMPAINA",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<CampainasInspeccion>(this.rwMapPK, "ID_CAMPAINA"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the CampainasInspeccion entity
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion Bean with the criteria values to filter
	 *            by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(CampainasInspeccion campainasinspeccion) {

		StringBuilder where = new StringBuilder(CampainasInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (campainasinspeccion != null && campainasinspeccion.getIdCampaina() != null) {
			where.append(" AND t1.ID_CAMPAINA = ?");
			params.add(campainasinspeccion.getIdCampaina());
		}
		if (campainasinspeccion != null && campainasinspeccion.getDireccion() != null
				&& campainasinspeccion.getDireccion().getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(campainasinspeccion.getDireccion().getIdDireccion());
		}
		if (campainasinspeccion != null && campainasinspeccion.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(campainasinspeccion.getDescripcionCastellano());
		}
		if (campainasinspeccion != null && campainasinspeccion.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(campainasinspeccion.getDescripcionEuskera());
		}
		if (campainasinspeccion != null && campainasinspeccion.getFechaInicio() != null) {
			where.append(" AND t1.FECHA_INICIO = ?");
			params.add(campainasinspeccion.getFechaInicio());
		}
		if (campainasinspeccion != null && campainasinspeccion.getFechaFin() != null) {
			where.append(" AND t1.FECHA_FIN = ?");
			params.add(campainasinspeccion.getFechaFin());
		}
		if (campainasinspeccion != null && campainasinspeccion.getIdentificadorCampaina() != null) {
			where.append(" AND t1.IDENTIFICADOR_CAMPAINA = ?");
			params.add(campainasinspeccion.getIdentificadorCampaina());
		}
		if (campainasinspeccion != null && campainasinspeccion.getProcedimiento() != null
				&& campainasinspeccion.getProcedimiento().getIdProcedimiento() != null) {
			where.append(" AND t1.ID_PROCEDIMIENTO = ?");
			params.add(campainasinspeccion.getProcedimiento().getIdProcedimiento());
		}
		if (campainasinspeccion != null && campainasinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(campainasinspeccion.getFechaRegistro());
		}
		if (campainasinspeccion != null && campainasinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(campainasinspeccion.getUsuarioRegistro());
		}
		if (campainasinspeccion != null && campainasinspeccion.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(campainasinspeccion.getFechaUltmodificacion());
		}
		if (campainasinspeccion != null && campainasinspeccion.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(campainasinspeccion.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the CampainasInspeccion entity
	 *
	 * @param campainasinspeccion
	 *            CampainasInspeccion Bean with the criteria values to filter
	 *            by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(CampainasInspeccion campainasinspeccion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(CampainasInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (campainasinspeccion != null && campainasinspeccion.getIdCampaina() != null) {
			where.append(" AND t1.ID_CAMPAINA = ?");
			params.add(campainasinspeccion.getIdCampaina());
		}
		if (campainasinspeccion != null && campainasinspeccion.getDireccion() != null
				&& campainasinspeccion.getDireccion().getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(campainasinspeccion.getDireccion().getIdDireccion());
		}
		if (campainasinspeccion != null && campainasinspeccion.getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(campainasinspeccion.getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + campainasinspeccion.getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (campainasinspeccion != null && campainasinspeccion.getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(campainasinspeccion.getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + campainasinspeccion.getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (campainasinspeccion != null && campainasinspeccion.getFechaInicioDesde() != null
				&& campainasinspeccion.getFechaInicioHasta() != null) {
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(campainasinspeccion.getFechaInicioHasta());
			calendar.add(Calendar.DAY_OF_YEAR, 1);
			where.append(" AND t1.FECHA_INICIO BETWEEN TO_DATE('"
					+ new SimpleDateFormat(Constantes.FORMATO_FECHA_ES)
							.format(campainasinspeccion.getFechaInicioDesde())
					+ "','" + Constantes.FORMATO_FECHA_ES + "') AND TO_DATE('"
					+ new SimpleDateFormat(Constantes.FORMATO_FECHA_ES).format(calendar.getTime()) + "','"
					+ Constantes.FORMATO_FECHA_ES + "')");
		} else if (campainasinspeccion != null && campainasinspeccion.getFechaInicioDesde() != null
				&& campainasinspeccion.getFechaInicioHasta() == null) {
			where.append(
					" AND t1.FECHA_INICIO > TO_DATE('"
							+ new SimpleDateFormat(Constantes.FORMATO_FECHA_ES)
									.format(campainasinspeccion.getFechaInicioDesde())
							+ "','" + Constantes.FORMATO_FECHA_ES + "')");
		} else if (campainasinspeccion != null && campainasinspeccion.getFechaInicioDesde() == null
				&& campainasinspeccion.getFechaInicioHasta() != null) {

			Calendar calendar = Calendar.getInstance();
			calendar.setTime(campainasinspeccion.getFechaInicioHasta());
			calendar.add(Calendar.DAY_OF_YEAR, 1);
			where.append(" AND t1.FECHA_INICIO < TO_DATE('"
					+ new SimpleDateFormat(Constantes.FORMATO_FECHA_ES).format(calendar.getTime()) + "','"
					+ Constantes.FORMATO_FECHA_ES + "')");
		}
		if (campainasinspeccion != null && campainasinspeccion.getFechaFinDesde() != null
				&& campainasinspeccion.getFechaFinHasta() != null) {
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(campainasinspeccion.getFechaFinHasta());
			calendar.add(Calendar.DAY_OF_YEAR, 1);
			where.append(" AND t1.FECHA_FIN BETWEEN TO_DATE('"
					+ new SimpleDateFormat(Constantes.FORMATO_FECHA_ES).format(campainasinspeccion.getFechaFinDesde())
					+ "','" + Constantes.FORMATO_FECHA_ES + "') AND TO_DATE('"
					+ new SimpleDateFormat(Constantes.FORMATO_FECHA_ES).format(calendar.getTime()) + "','"
					+ Constantes.FORMATO_FECHA_ES + "')");
		} else if (campainasinspeccion != null && campainasinspeccion.getFechaFinDesde() != null
				&& campainasinspeccion.getFechaFinHasta() == null) {
			where.append(" AND t1.FECHA_FIN > TO_DATE('"
					+ new SimpleDateFormat(Constantes.FORMATO_FECHA_ES).format(campainasinspeccion.getFechaFinDesde())
					+ "','" + Constantes.FORMATO_FECHA_ES + "')");
		} else if (campainasinspeccion != null && campainasinspeccion.getFechaFinDesde() == null
				&& campainasinspeccion.getFechaFinHasta() != null) {

			Calendar calendar = Calendar.getInstance();
			calendar.setTime(campainasinspeccion.getFechaFinHasta());
			calendar.add(Calendar.DAY_OF_YEAR, 1);
			where.append(" AND t1.FECHA_FIN < TO_DATE('"
					+ new SimpleDateFormat(Constantes.FORMATO_FECHA_ES).format(calendar.getTime()) + "','"
					+ Constantes.FORMATO_FECHA_ES + "')");
		}
		if (campainasinspeccion != null && campainasinspeccion.getIdentificadorCampaina() != null) {
			where.append(" AND UPPER(t1.IDENTIFICADOR_CAMPAINA) like ? ESCAPE '\\'");
			if (startsWith) {
				params.add(campainasinspeccion.getIdentificadorCampaina().toUpperCase() + "%");
			} else {
				params.add("%" + campainasinspeccion.getIdentificadorCampaina().toUpperCase() + "%");
			}
			where.append(" AND t1.IDENTIFICADOR_CAMPAINA IS NOT NULL");
		}
		if (campainasinspeccion != null && campainasinspeccion.getProcedimiento() != null
				&& campainasinspeccion.getProcedimiento().getIdProcedimiento() != null) {
			where.append(" AND t1.ID_PROCEDIMIENTO = ?");
			params.add(campainasinspeccion.getProcedimiento().getIdProcedimiento());
		}
		if (campainasinspeccion != null && campainasinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(campainasinspeccion.getFechaRegistro());
		}
		if (campainasinspeccion != null && campainasinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(campainasinspeccion.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + campainasinspeccion.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (campainasinspeccion != null && campainasinspeccion.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(campainasinspeccion.getFechaUltmodificacion());
		}
		if (campainasinspeccion != null && campainasinspeccion.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE '\\'");
			if (startsWith) {
				params.add(campainasinspeccion.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + campainasinspeccion.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
